﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void ultraComboEditor1_AfterDropDown(object sender, EventArgs e)
        {
            LoadDataTable();
        }

        private void comboBox1_DropDown(object sender, EventArgs e)
        {
            LoadDataTable();
        }

        private void LoadDataTable()
        {
            BackgroundWorker bw = new BackgroundWorker();
            bw.DoWork += new DoWorkEventHandler(bw_DoWork);
            bw.RunWorkerCompleted += new RunWorkerCompletedEventHandler(bw_RunWorkerCompleted);
            bw.RunWorkerAsync();
        }

        private void bw_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            DataTable dt = e.Result as DataTable;

            ultraComboEditor1.DataSource = dt;
            ultraComboEditor1.ValueMember = "Value";
            ultraComboEditor1.DisplayMember = "Text";
            ultraComboEditor1.Invalidate();

            comboBox1.DataSource = dt;
            comboBox1.ValueMember = "Value";
            comboBox1.DisplayMember = "Text";
            comboBox1.Invalidate();
        }

        private void bw_DoWork(object sender, DoWorkEventArgs e)
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("Text", typeof(string));
            dt.Columns.Add("Value", typeof(object));

            for (int i = 0; i <= 1000; i++)
            {
                dt.Rows.Add("Value " + i.ToString(), i);
            }

            e.Result = dt;
        }
    }
}
